<template>
    <div class="card shadow-none image-picker">
        <div class="crop-wrapper" v-if="showCropper">
            <button type="button" class="btn btn-sm btn-success" ref="cropperBtn">Cortar</button>
            <button type="button" class="btn btn-sm btn-default" v-on:click="rotate('left')"><i class="fa fa-undo"></i></button>
            <button type="button" class="btn btn-sm btn-default" v-on:click="rotate('right')"><i class="fa fa-redo"></i></button>
            <img src="" alt="Image" ref="cropperImg">
        </div>

        <img class="card-img-top" :src="urlImage" alt="">
        <template v-if="isValidFile">
            <input type="hidden" :name="fileNames" :value="filename">
            <input type="hidden" :name="fileContents" :value="urlImage">
        </template>
        <div class="card-body p-0">
            <div class="custom-file w-100 mt-2 align-self-end">
                <input type="file" class="custom-file-input"
                    name="file"
                    ref="fileInput"
                    :disabled="disabled"
                    :accept="fileAccept"
                    @change="validate($event)">
                <label class="custom-file-label" for="logo_photo">Seleccionar imagen</label>
            </div>
        </div>
    </div>
</template>

<script>
import Cropper from 'cropperjs';

export default {
    data() {
        return {
            showCropper: false,
            urlImage: this.srcImage,
            filename: null,
            isValidFile: false,
            cropper: null,
            angle: 0
        };
    },
    props: {
        //url de la imagensrc of image
        srcImage: {
            type: String,
            default: ''
        },
        // Tamaño maximo de cada archivo
        filesSize: {
            type: Number,
            default: 2097152
        },
        // Formatos aceptados
        fileAccept: {
            type: String,
            default: 'image/jpg,image/jpeg,image/png,image/gif'
        },
        // Deshabilitar el boton para seleccionar archivo
        disabled: {
            type: Boolean,
            default: false
        },
        // Donde se almacenara el nombre del archivo
        fileNames: {
            type: String,
            default: 'image_profile_filename'
        },
        // Donde se almacenara el archivo base64
        fileContents: {
            type: String,
            default: 'image_profile'
        }
    },
    methods: {
        // Validar el archivo seleccionado
        validate(evt) {
            const {files} = evt.target;
            var accept = this.fileAccept;
            accept = accept.replace(new RegExp(',', 'g'), '|');
            const mimeRegExp = new RegExp(accept);
            this.isValidFile = false;

            // Validar el tamaño de los archivos
            for (let file of files) {
                // Validamos la extensión
                if (mimeRegExp.exec(file.type) === null) {
                    swal("Error", "Solo están permitidos los siguientes tipos de archivo: " + this.fileAccept, 'error');
                    this.$refs.fileInput.value = '';
                    return false;
                }
                if (file.size > this.fileSize) {
                    swal("Error", "Los archivos no deben ser mayores que " + this.fileSize + " bytes", 'error');
                    this.$refs.fileInput.value = '';
                    return false;
                }
            }

            // Reiniciamos la url de la imagen
            this.$refs.cropperImg = '';
            this.showCropper = true;
            if (files.length > 0) {
                let file = files[0];
                // console.log("file", file);
                let reader = new FileReader();

                reader.onload = (evt) => {
                    // Obtenemos el url de la imagen seleccionada
                    this.$refs.cropperImg.src = reader.result;
                    // this.urlImage= reader.result;
                    var ratio = 16 / 9;
                    if (this.$el.attributes['data-ratio']) {
                        if (this.$el.attributes['data-ratio'] === 'free') {
                            ratio = NaN;
                        }
                        else {
                            ratio = parseFloat(this.$el.attributes['data-ratio'].value);
                        }
                    }
                    // Creamos nueva instancia del objeto a cortar
                    this.cropper = new Cropper(this.$refs.cropperImg, {
                        aspectRatio: ratio,
                        guides: true,
                        viewMode: 1,
                        ragMode: 'crop',
                        autoCropArea: .5,
                        minContainerWidth: 400,
                        minContainerHeight: 300,
                        background: true,
                        rotatable: true
                    });
                    // Agregamos evento al boton para cortar la imagen
                    this.$refs.cropperBtn.addEventListener('click', (evt) => {
                        evt.preventDefault();
                        //Actualizamos los datos de nuestra imagen y reseteamos el input
                        this.urlImage= this.cropper.getCroppedCanvas().toDataURL(file.type);
                        this.filename= file.name;
                        this.isValidFile = true;
                        this.$refs.fileInput.value = '';
                        // Destruimos el objeto cropper y lo ocultamos
                        this.cropper.destroy();
                        this.showCropper = false;
                        //lanzamos evento, que indica que la imagen fue valida
                        this.$emit('imageAdded');
                    });
                };
                reader.readAsDataURL(file);
            }
        },
        rotate(dir) {
            if (dir === 'left') {
                if (this.angle > -360) {
                    this.angle -= 45;
                }
            }
            else {
                if (this.angle < 360) {
                    this.angle +=45;
                }
            }
            this.cropper.rotate(this.angle);
        }
    }
}
</script>

<style>
    .crop-wrapper {
        width: auto !important;
        height: 400px;
    }
    .crop-wrapper button {
        margin-bottom: 0.5rem;
    }
    .crop-wrapper img {
        max-height: 90rem;
    }
</style>